<template>
  <div class="mt-form-fields-activity">
    <div class="mt-fields-section">
      <slot></slot>
      <b-field class="mt-fields-section" label="Nom de l’activité ">
        <b-input v-model="activite.nom" placeholder="Ex: Activité 1" required class="mt-input marge" />
      </b-field>
      <b-field class="mt-fields-section" label="Description">
        <mt-focus-warning>
          <template #message
            >Ne pas renseigner d’informations relatives à la localisation d’une activité. Indiquez seulement le
            département si nécessaire.</template
          >
          <b-field>
            <b-input
              v-model="activite.description"
              type="textarea"
              placeholder="Rédigez une description."
              class="mt-input marge"
              maxlength="500"
            />
          </b-field>
        </mt-focus-warning>
      </b-field>
      <b-field class="mt-fake-field" label="Typologie d'activité"></b-field>
      <b-field class="mt-type">
        <b-radio-button
          v-for="(typeActivite, index) in appTypesActivites"
          :key="index"
          v-model="activite.typeActivite.id"
          :native-value="typeActivite.id"
          :disabled="fromParent"
          :class="resolveTypeActivite({ typeActivite }, 'mt-type-').class"
        >
          <span>{{ typeActivite.libelle }}</span
          >&nbsp;<b-icon :icon="typeActivite.codeCssIcone" />
        </b-radio-button>
      </b-field>
    </div>

    <section class="mt-fields-section columns">
      <b-field label="date de Début" class="column is-one-third is-half-mobile">
        <b-datepicker
          v-model="activite.dateDebut"
          placeholder="Sélectionnez une date de debut"
          :first-day-of-week="1"
          :month-names="monthNames"
          :day-names="dayNames"
          :date-parser="dateParse"
          editable
          icon="calendar-today"
          class="mt-input"
          :disabled="modifier || fromParent"
          @input="majEffectifPrevisionnelDebut"
        />
      </b-field>
      <b-field label="date de Fin" class="column is-one-third is-half-mobile">
        <b-datepicker
          v-model="activite.dateFin"
          placeholder="Sélectionnez une date de fin"
          :first-day-of-week="1"
          :month-names="monthNames"
          :day-names="dayNames"
          :date-parser="dateParse"
          editable
          icon="calendar-today"
          class="mt-input"
          :disabled="modifier || fromParent"
          @input="majEffectifPrevisionnelFin"
        />
      </b-field>
    </section>
    <section class="mt-fields-section">
      <b-field class="mt-fake-field" label="Effectif potentiel"></b-field>
      <div class="columns is-mobile is-vcentered is-multiline">
        <div v-for="(corp, index) in effectifPrevisionnel.corps" :key="index" class="column is-half-mobile">
          <label class="label label-secondary columns is-vcentered is-mobile">
            <span class="column is-narrow ">{{ corp.libelle }}</span>
            <b class="column is-narrow">{{ corp.count }}</b></label
          >
        </div>
      </div>
    </section>
    <section class="mt-fields-section">
      <label class="label">Effectif nécessaire</label>
      <div class="columns">
        <div v-for="(effectif, index) in activite.effectifs" :key="index" class="column is-3">
          <b-field :label="effectif.corps.libelle" custom-class="label-secondary">
            <b-input v-model="effectif.nombre" type="number" min="0" class="mt-input" @input="uncheck(index)" />
          </b-field>
          <b-checkbox v-model="checked[index]" class="checkboxTous" @input="ajouterNombrePaxMax(index)"
            >Tous ({{ getNombrePax(index) }})</b-checkbox
          >
        </div>
      </div>
    </section>
    <section class="mt-fields-section">
      <label class="label">Paramétrer une alerte de création d’activité </label>
      <mt-message-info class="margin-message"
        >Cette option enverra une alerte par email à tous les pax de votre unité les informant de cette nouvelle
        activité.
      </mt-message-info>
      <div class="columns">
        <div class="column is-narrow">
          <b-switch v-model="activite.envoyerMailCreation" class="mt-swith" :disabled="modifier">
            Alerte par email
          </b-switch>
        </div>
      </div>
    </section>
    <section class="mt-fields-section">
      <label class="label">Paramétrer un rappel d'inscription</label>
      <mt-message-info class="margin-message"
        >Cette option permet de rappeler aux pax non inscrits de déclarer leurs disponibilités et/ou de candidater à
        l'activité.</mt-message-info
      >
      <div class="columns">
        <div class="column is-narrow">
          <b-switch v-model="rappel" class="mt-swith" @input="chkRappel">
            Rappel
          </b-switch>
        </div>
        <div class="column is-narrow">
          <b-checkbox v-model="activite.rappelInApp" :disabled="!rappel" name="rappelinapp" @input="verifRappel"
            >In-App</b-checkbox
          >
        </div>
        <div class="column is-narrow">
          <b-checkbox v-model="activite.rappelEmail" :disabled="!rappel" name="rappelemail" @input="verifRappel"
            >Par mail</b-checkbox
          >
        </div>
      </div>
      <div class="columns is-vcentered">
        <div class="column is-2">
          <b-field custom-class="label-secondary">
            <b-input
              v-model="activite.rappelNbJourAvantDebut"
              type="number"
              min="0"
              class="mt-input"
              :disabled="!rappel"
              @input="majDateRappel"
            />
          </b-field>
        </div>
        <div class="column">
          Jours avant la date de début de l’activité <small>({{ majDateRappel() }})</small>.
        </div>
      </div>
    </section>
    <section class="mt-fields-section">
      <label class="label">Paramétrer un rappel de participation</label>
      <mt-message-info class="margin-message"
        >Cette option permet de rappeler aux pax convoqués qu'ils doivent être présents le jour de
        l'activité.</mt-message-info
      >
      <div class="columns">
        <div class="column is-narrow">
          <b-switch v-model="rappelParticipation" class="mt-swith" @input="chkRappelParticipation">
            Rappel
          </b-switch>
        </div>
        <div class="column is-narrow">
          <b-checkbox
            v-model="activite.rappelParticipationInApp"
            :disabled="!rappelParticipation"
            name="rappelparticipationinapp"
            @input="verifRappelParticipation"
            >In-App</b-checkbox
          >
        </div>
        <div class="column is-narrow">
          <b-checkbox
            v-model="activite.rappelParticipationEmail"
            :disabled="!rappelParticipation"
            name="rappelparticipationemail"
            @input="verifRappelParticipation"
            >Par mail</b-checkbox
          >
        </div>
      </div>
      <div class="columns is-vcentered">
        <div class="column is-2">
          <b-field custom-class="label-secondary">
            <b-input
              v-model="activite.rappelParticipationNbJourAvantDebut"
              type="number"
              min="0"
              class="mt-input"
              :disabled="!rappelParticipation"
              @input="majDateRappelParticipation"
            />
          </b-field>
        </div>
        <div class="column">
          Jours avant la date de début de l’activité <small>({{ majDateRappelParticipation() }})</small>.
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import { classResolver } from '~/components/mixins/activityMixin';
import userMixin from '~/components/mixins/userMixin';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';
import MtFocusWarning from '~/components/base/focus-warning/mt-focus-warning';
import MtMessageInfo from '~/components/base/message/mt-message-info';

export default {
  components: { MtMessageInfo, MtFocusWarning },
  mixins: [classResolver, userMixin, DayMonthMixin],
  props: {
    activite: {
      type: Object,
      default: () => ({}),
    },
    effectifPrevisionnel: {
      type: Object,
      default: () => ({}),
    },
    modifier: {
      type: Boolean,
      default: false,
    },
    fromParent: {
      type: Boolean,
      default: false,
    },
    paxMax: {
      type: Object,
      default: () => ({}),
    },
    organismes: {
      type: Array,
      default: () => [],
    },
  },

  data() {
    return {
      rappel: false,
      nombrePaxSasie: [],
      checked: [],
      rappelParticipation: false,
    };
  },

  created() {
    this.rappel = this.activite.rappelInApp || this.activite.rappelEmail;
    this.rappelParticipation = this.activite.rappelParticipationInApp || this.activite.rappelParticipationEmail;
  },

  methods: {
    uncheck(index) {
      this.checked[index] = false;
    },
    ajouterNombrePaxMax(index) {
      if (this.checked[index] === true) {
        this.nombrePaxSasie[index] = this.activite.effectifs[index].nombre;
        this.activite.effectifs[index].nombre = this.paxMax.nombrePax[index];
      } else {
        this.activite.effectifs[index].nombre = this.nombrePaxSasie[index];
      }
    },
    getNombrePax(index) {
      return this.paxMax.nombrePax[index];
    },
    majEffectifPrevisionnelDebut() {
      if (this.activite.dateDebut > this.activite.dateFin) {
        this.activite.dateFin = this.activite.dateDebut;
      }
      this.$emit('majEffectifPrevisionnel');
    },
    majEffectifPrevisionnelFin() {
      if (this.activite.dateFin < this.activite.dateDebut) {
        this.activite.dateDebut = this.activite.dateFin;
      }
      this.$emit('majEffectifPrevisionnel');
    },
    majDateRappel() {
      let start = DateTime.fromJSDate(this.activite.dateDebut);
      start = start.minus({ days: this.activite.rappelNbJourAvantDebut });
      return start.setLocale('fr').toFormat('dd/MM/yyyy');
    },
    majDateRappelParticipation() {
      let start = DateTime.fromJSDate(this.activite.dateDebut);
      start = start.minus({ days: this.activite.rappelParticipationNbJourAvantDebut });
      return start.setLocale('fr').toFormat('dd/MM/yyyy');
    },
    chkRappel() {
      this.activite.rappelInApp = this.rappel;
      this.activite.rappelEmail = this.rappel;
    },
    chkRappelParticipation() {
      this.activite.rappelParticipationInApp = this.rappelParticipation;
      this.activite.rappelParticipationEmail = this.rappelParticipation;
    },
    verifRappel() {
      this.rappel = this.activite.rappelInApp || this.activite.rappelEmail;
    },
    verifRappelParticipation() {
      this.rappelParticipation = this.activite.rappelParticipationInApp || this.activite.rappelParticipationEmail;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

/deep/ {
  .label.label.label-secondary {
    b {
      color: $grey-dark;
      margin-left: 0.8rem;
      font-size: $size-6;
    }
  }
}

/deep/ .checkboxTous input {
  visibility: hidden;

  & ~ .control-label {
    border-radius: 2rem;
    background-color: $pale-grey;
    color: #666ee8;
    font-size: $size-7;
    padding: 0.5em 1em;
    margin: 0 0.25em;

    text-align: center;
    cursor: pointer;
    transition-property: background-color, color;
    transition-duration: 0.3s;
    display: flex;
    align-items: center;

    .icon {
      margin-right: 0.8em;
    }
  }
  &:checked ~ .control-label,
  & ~ .control-label:hover {
    border-color: $soft-blue;
    background-color: $soft-blue;
    color: $white;
  }

  & + .check {
    display: none !important;
    visibility: hidden;
  }
}
h3 {
  font-weight: bold;
  margin-bottom: 1rem;
}
.mt-fields-section {
  margin-bottom: 2.1875rem;
}
.mt-fake-field {
  margin-bottom: 0;
}
.mt-form-fields-activity {
  margin-bottom: 2.25rem;
}
.margin-message {
  margin-bottom: 1rem;
}
/deep/ .b-checkbox.checkbox input[type='checkbox']:disabled + .check {
  border: solid 1px $brown-grey;
}
.marge {
  margin-bottom: 2.188rem;
}
</style>
